---
title: CacheStorage.match()
slug: Web/API/CacheStorage/match
tags:
  - API
  - CacheStorage
  - Experimental
  - Method
  - Reference
  - Service Workers
  - Service worker API
  - ServiceWorker
  - match
---
<p>{{APIRef("Service Workers API")}}</p>

<p><span class="seoSummary">The <strong><code>match()</code></strong> method of the {{domxref("CacheStorage")}} interface checks if a given {{domxref("Request")}} or url string is a key for a stored {{domxref("Response")}}. This method returns a {{jsxref("Promise")}} for a {{domxref("Response")}}, or a {{jsxref("Promise")}} which resolves to <code>undefined</code> if no match is found.</span></p>

<p>You can access <code>CacheStorage</code> through the global {{domxref("WindowOrWorkerGlobalScope.caches", "caches")}} property.</p>

<p><code>Cache</code> objects are searched in creation order.</p>

<div class="note"><strong>Note</strong>: {{domxref("CacheStorage.match()", "caches.match()")}} is a convenience method. Equivalent functionality is to call {{domxref("cache.match()")}} on each cache (in the order returned by {{domxref("CacheStorage.keys()", "caches.keys()")}}) until a {{domxref("Response")}} is returned.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">caches.match(<em>request</em>, <em>options</em>).then(function(<em>response</em>) {
  // Do something with the response
});
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>request</dt>
 <dd>The {{domxref("Request")}} you want to match.  This can be a  {{domxref("Request")}} object or a URL string.</dd>
 <dt>options {{optional_inline}}</dt>
 <dd>An object whose properties control how matching is done in the <code>match</code> operation. The available options are:
 <ul>
  <li><code>ignoreSearch</code>: A {{jsxref("Boolean")}} that specifies whether the matching process should ignore the query string in the url.  For example, if set to <code>true</code>, the <code>?value=bar</code> part of <code>http://foo.com/?value=bar</code> would be ignored when performing a match. It defaults to <code>false</code>.</li>
  <li><code>ignoreMethod</code>: A {{jsxref("Boolean")}} that, when set to <code>true</code>, prevents matching operations from validating the {{domxref("Request")}} <code>http</code> method (normally only <code>GET</code> and <code>HEAD</code> are allowed.) It defaults to <code>false</code>.</li>
  <li><code>ignoreVary</code>: A {{jsxref("Boolean")}} that, when set to <code>true,</code> tells the matching operation not to perform <code>VARY</code> header matching. In other words, if the URL matches you will get a match regardless of whether the {{domxref("Response")}} object has a <code>VARY</code> header or not. It defaults to <code>false</code>.</li>
  <li><code>cacheName</code>: A {{domxref("DOMString")}} that represents a specific cache to search within.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>a {{jsxref("Promise")}} that resolves to the matching {{domxref("Response")}}. If no matching response to the specified request is found, the promise resolves with <code>undefined</code>.</p>

<h2 id="Examples" style="line-height: 30px; font-size: 2.14285714285714rem;">Examples</h2>

<p>This example is from the MDN <a href="https://github.com/mdn/sw-test/">sw-test example</a> (see <a href="https://mdn.github.io/sw-test/">sw-test running live</a>). Here we wait for a {{domxref("FetchEvent")}} to fire. We construct a custom response like so:</p>

<ol>
 <li>Check whether a match for the request is found in the {{domxref("CacheStorage")}} using {{domxref("CacheStorage.match","CacheStorage.match()")}}. If so, serve that.</li>
 <li>If not, open the <code>v1</code> cache using <code>open()</code>, put the default network request in the cache using {{domxref("Cache.put","Cache.put()")}} and return a clone of the default network request using <code>return response.clone()</code>. The last is necessary because <code>put()</code> consumes the response body.</li>
 <li>If this fails (e.g., because the network is down), return a fallback response.</li>
</ol>

<pre class="brush: js notranslate">self.addEventListener('fetch', function(event) {
  event.respondWith(caches.match(event.request).then(function(response) {
    // caches.match() always resolves
    // but in case of success response will have value
    if (response !== undefined) {
      return response;
    } else {
      return fetch(event.request).then(function (response) {
        // response may be used only once
        // we need to save clone to put one copy in cache
        // and serve second one
        let responseClone = response.clone();

        caches.open('v1').then(function (cache) {
          cache.put(event.request, responseClone);
        });
        return response;
      }).catch(function () {
        return caches.match('/sw-test/gallery/myLittleVader.jpg');
      });
    }
  }));
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#cache-storage-match', 'CacheStorage: match')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CacheStorage.match")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li>{{domxref("Cache")}}</li>
 <li>{{domxref("WindowOrWorkerGlobalScope.caches")}}</li>
</ul>
